
// Horribly stolen from the duplicator stool.
// I'm not good at writing stools :x

AddCSLuaFile( "vgui/saver_gui.lua" )
AddCSLuaFile( "vgui/saver_gui_button.lua" )

TOOL.Category		= "HAT Tools"
TOOL.Name			= "Saver"
TOOL.Command		= nil
TOOL.ConfigName		= ""
TOOL.Stored			= true

if (CLIENT) then

	language.Add("Tool_hanim_save_name","Saver")
	language.Add("Tool_hanim_save_desc","Saves an entity's animation data.")
	language.Add("Tool_hanim_save_0","Primary: Load saved animation into entity. Secondary: Select entity to save it's animation.")

end

local Loaded

function TOOL:LeftClick( trace )

	if type(trace.Entity) != "Entity" and type(trace.Entity) != "Vehicle" then return end
	if ( SERVER ) then
		if SinglePlayer() then hanim.clLeftClickHanimSave(trace.Entity) end
		return true
	end
	if !hanim.StoolLoad then return end
	hanim.servLoad(trace.Entity,hanim.StoolLoad)
	return true
	
end

function TOOL:RightClick( trace )

	if type(trace.Entity) != "Entity" and type(trace.Entity) != "Vehicle" then return end
	if ( SERVER ) then
		if SinglePlayer() then hanim.clRightClickHanimSave(trace.Entity) end
		return true
	end
	hanim.StoolEnt = trace.Entity
	return true
	
end

if (SERVER) then
	if SinglePlayer() then hanim.Hook("clRightClickHanimSave") hanim.Hook("clLeftClickHanimSave") end
end

if (CLIENT) then
	if SinglePlayer() then
		function hanim.clRightClickHanimSave(ent)
			hanim.StoolEnt = ent
		end
		function hanim.clLeftClickHanimSave(ent)
			if !hanim.StoolLoad then return end
			hanim.servLoad(ent,hanim.StoolLoad)
		end
	end

	local DuplicatorControl = nil
	
	hanim.DupArgs = {}
	
	function hanim.RePop(dec)
		local files = glon.decode(dec)
		if !DuplicatorControl then
			hanim.DupArgs=files
		else
			DuplicatorControl:RePop(files)
		end
	end
	
	local pnldef_Duplicator = vgui.RegisterFile( "vgui/saver_gui.lua" )
	
	/*---------------------------------------------------------
		Builds the context menu
	---------------------------------------------------------*/
	function TOOL.BuildCPanel( CPanel )
	
		CPanel:AddControl( "Header", { Text = "#Tool_duplicator_name", Description	= "#Tool_duplicator_desc" }  )
		
		DuplicatorControl = vgui.CreateFromTable( pnldef_Duplicator )
		CPanel:AddPanel( DuplicatorControl )
	
		PrintTable(hanim.DupArgs)
		DuplicatorControl:RePop(hanim.DupArgs)
			
	end
	

	/*---------------------------------------------------------
		Receives the usermessages
	---------------------------------------------------------*/
	local function RecvFunc( m )
	
		local id = m:ReadShort()
		
		if ( id == 0 ) then
			DuplicatorControl:Clear()
			return
		end
		
		if ( id == 1000 ) then
			DuplicatorControl:Populate()
			return
		end
		
		
	end
	
	usermessage.Hook( "Duplications", RecvFunc )


end
