
AddCSLuaFile("HAT_initiate.lua")
AddCSLuaFile("./client/HAT_client.lua")

require("glon")


//hook.Add( "PostGamemodeLoaded", "GamemodeLoadHATShared", GamemodeLoadHATShared )

// I didn't obfuscerate this code, it's just so chronically confusing that it makes even MY head hurt.
// If you'd like, you can help clean up the code! :D

MsgN("Henry's Animation Tools Beta 2 Shared Initiated")

if _G["hanim"] then

	MsgN("HAT Error! Conflict with separate addon.")
	MsgN("Overriding.")
	
	if _G["hanim"].ishat then
	
		MsgN("Reloading HAT.")
		
	end
	
end

_G["hanim"] = {}

hanim.PostLoadedSends = {}

// Positive # will return 1, negative will return -1, zero will return 0.
function tonorm (n)
	
	if n == 0 then return 0 end
	return n/n

end

// My own custom hooking system. I use it to replace datastream.
// It allows clients to run server functions and the server to run client functions.
// Run function hanim.Hook("functionname"), then you'll be able to call that function through either server or client.
// Function must exist in the "hanim" table.

local function hanim_Send(...)
	if type(arg[1]) != "string" then return end
	if !arg[1] then return end
	
	if CLIENT then
		local outp = {}
		table.insert(outp,arg[1])
		for i=2,#arg do
			local v = arg[i]
			if type(v) == "string" then
				table.insert(outp,"s"..v)
			elseif type(v) == "number" then
				table.insert(outp,"n"..v)
			elseif type(v) == "nil" then
				table.insert(outp,"0")
			elseif type(v) == "Entity" or type(v) == "NPC" or type(v) == "Weapon" or type(v) == "Vehicle" then
				table.insert(outp,"e"..v:EntIndex())
			elseif type(v) == "Vector" then
				table.insert(outp,"v"..v.x.."/"..v.y.."/"..v.z)
			elseif type(v) == "Angle" then
				table.insert(outp,"a"..v.p.."/"..v.y.."/"..v.r)
			elseif type(v) == "boolean" then
				if v then
					table.insert(outp,"t")
				else
					table.insert(outp,"f")
				end
			end
		end
		RunConsoleCommand("hanim_send",unpack(outp))
	else
		if hanim.HookList then
			for k,v in ipairs(hanim.HookList) do
				rp = RecipientFilter()
				rp:AddPlayer(v)
			end
			umsg.Start("hanim_send",rp)
		else
			umsg.Start("hanim_send")
		end
			umsg.String(arg[1])
			local str = ""
			for i=2,#arg do
				local v = arg[i]
				if type(v) == "string" then
					str = str.."s"
				elseif type(v) == "nil" then
					str = str.."0"
				elseif type(v) == "number" then
					str = str.."n"
				elseif type(v) == "Entity" or type(v) == "NPC" or type(v) == "Weapon" or type(v) == "Vehicle" then
					str = str.."e"
				elseif type(v) == "Vector" then
					str = str.."v"
				elseif type(v) == "Angle" then
					str = str.."a"
				elseif type(v) == "boolean" then
					str = str.."b"
				end
			end
			umsg.String(str)
			for i=2,#arg do
				local v = arg[i]
				if type(v) == "string" or type(v) == "number" then
					umsg.String(v) // Float and long seem to round mah numbaz up :(
				elseif type(v) == "Entity" or type(v) == "NPC" or type(v) == "Weapon" or type(v) == "Vehicle" then
					umsg.Entity(v)
				elseif type(v) == "Vector" then
					umsg.Vector(v)
				elseif type(v) == "Angle" then
					umsg.Angle(v)
				elseif type(v) == "boolean" then
					umsg.Bool(v)
				end
			end
		umsg.End()
		hanim.HookList = nil
	end
end

function hanim.Hook(s)
	if type(s) != "string" then return end
	if string.len(s) <= 0 then return end
	hanim[s] = function(...) hanim_Send(s,...) end
end

if CLIENT then

local function hanim_send_recieve(umsg)
	local funct = umsg:ReadString()
	local chart = umsg:ReadString()
	local args = {}
	for i=1,string.len(chart) do
		local v = string.sub(chart,i,i)
		if v == "s" then
			table.insert(args,umsg:ReadString())
		elseif v == "0" then
			table.insert(args,0)
		elseif v == "n" then
			table.insert(args,tonumber(umsg:ReadString()))
		elseif v == "e" then
			table.insert(args,umsg:ReadEntity())
		elseif v == "v" then
			table.insert(args,umsg:ReadVector())
		elseif v == "a" then
			table.insert(args,umsg:ReadAngle())
		elseif v == "b" then
			table.insert(args,umsg:ReadBool())
		end
	end
	if hanim[funct] then
		hanim[funct](unpack(args))
	else
		table.insert(hanim.PostLoadedSends,function() hanim[funct](unpack(args)) end)
	end
end
usermessage.Hook( "hanim_send", hanim_send_recieve )

else

function hanim_send_recieve(pl,cmd,args)
	if #args < 1 then return end
	if !pl:IsValid() then return end
	if !pl:IsPlayer() then return end
	local funct = args[1]
	local output = {}
	for i=2,#args do
		local v = string.sub(args[i],1,1)
		local o = string.sub(args[i],2)
		if v == "s" then
			table.insert(output,o)
		elseif v == "n" then
			table.insert(output,tonumber(o))
		elseif v == "e" then
			table.insert(output,ents.GetByIndex(tonumber(o)))
		elseif v == "v" then
			local vector = string.Explode("/",o)
			table.insert(output,Vector(vector[1],vector[2],vector[3]))
		elseif v == "a" then
			local angle = string.Explode("/",o)
			table.insert(output,Angle(angle[1],angle[2],angle[3]))
		elseif v == "t" then
			table.insert(output,true)
		elseif v == "f" then
			table.insert(output,false)
		end
	end
	hanim[funct](unpack(output))
end
concommand.Add("hanim_send", hanim_send_recieve)

end