
ENT.Base = "base_entity"
ENT.Type = "anim"

function ENT:Initialize()

	//self:SetRagdollBones( true )
	self.m_bRagdollSetup = true
	
	self.Entity:DrawShadow( false )
	self.Entity:SetMoveType( MOVETYPE_NONE )
	self.Entity:SetSolid( SOLID_VPHYSICS )
	self.Entity:SetNotSolid( true )

end

function ENT:DoRagdollBone( PhysBoneNum, BoneNum )

	if !hanim.CurFrame then return end
	if self.Entity.anim and self.Entity.anim:IsValid() then
		if hanim.bonematrixes[self.Entity:EntIndex()..(hanim.CurFrame-1)] then
			local mat = hanim.bonematrixes[self.Entity:EntIndex()..(hanim.CurFrame-1)][BoneNum]
			if self.Entity.anim:TranslateBoneToPhysBone(BoneNum) > -1 then
				self:SetBonePosition( BoneNum, mat[1], mat[2] )
			end
		end
	end
	
end

function ENT:Think()

	if !hanim.CurFrame then return end
	if hanim.bonematrixes[self.Entity:EntIndex()..(hanim.CurFrame-1)] then
		local pos = hanim.bonematrixes[self.Entity:EntIndex()..(hanim.CurFrame-1)][0][3]
		local ang = hanim.bonematrixes[self.Entity:EntIndex()..(hanim.CurFrame-1)][0][4]
		if pos then
			self.Entity:SetPos(pos)
			self.Entity:SetAngles(ang)
		end
		self.Entity:SetSkin(self.Entity.anim:GetSkin())
	end
end

function ENT:Draw()
	self.Entity:DrawModel()
end

function ENT:DrawTranslucent()
	if !hanim.CurFrame then return end
	self.Entity.anim = self.Entity:GetNWEntity("ent")
	if self.Entity.anim and self.Entity.anim:IsValid() then
		if hanim.bonematrixes[self.Entity:EntIndex()..(hanim.CurFrame-1)] then
			self.Entity:DrawModel()
		end
	end
end
