
ENT.Base = "base_entity"
ENT.Type = "anim"

AddCSLuaFile("cl_init.lua")

local VarsOnHand = 5 * 3
local FingerVars = VarsOnHand * 2

function ENT:Initialize()
	self.Entity:SetRenderMode( RENDERMODE_TRANSALPHA )
	self.Entity:SetColor( 255, 255, 255, 150 )
	//self.Entity:SetModel("models/weapons/w_bugbait.mdl")
	if !self.Entity.frames or !self.Entity.anim then
		self.Entity.frames = {}
		self.Entity.anim = {}
	end
	self.Entity:SetModel("models/weapons/w_bugbait.mdl")
	//self.Entity:SetColor(255,255,255,155)
end

function ENT:SetAnimEnt(e)
	if !e then return end
	if !e:IsValid() then return end
	
	self.Entity.anim = e
	return true
end

//function ENT:Think()
//	self.Entity:SetVelocity(Vector((math.random(0,1)-1)*1000,(math.random(0,1)-1)*1000,(math.random(0,1)-1)*1000))
//end

function ENT:Wink()

	if !self.Entity.anim then return end

	if hanim.IsPlaying then
		self:Beatlemania( hanim.CurFrame, math.Clamp(hanim.CurFrame+1,0,hanim.FrameCount), math.ceil(hanim.div((CurTime()-hanim.CurTime),hanim.GetFrameWang(hanim.CurFrame,true))*1000)/1000, true )
		//hanim.BeatlemaniaTime( hanim.CurFrame,math.Clamp(hanim.CurFrame+1,0,hanim.FrameCount), math.ceil(hanim.div((CurTime()-hanim.CurTime),hanim.GetFrameWang(hanim.CurFrame,true))*1000)/1000, true )
	else
		if self.OldFrame != hanim.CurFrame or self.OldPlaying != hanim.IsPlaying then
			self:Beatlemania( hanim.CurFrame )
		end
		self.OldFrame = hanim.CurFrame
	end
	self.OldPlaying = hanim.IsPlaying
	
	self:NextThink(CurTime()+hanim._lag:GetFloat())
	return true
end

local function ConvertRelativeToEyesAttachment( Entity, Ang )

	// Convert relative to eye attachment
	local eyeattachment = Entity:LookupAttachment( "eyes" )
	if ( eyeattachment == 0 ) then return end
	local attachment = Entity:GetAttachment( eyeattachment )
	if ( !attachment ) then return end
	
	Pos = attachment.Pos + Ang:Forward()*3

	local LocalPos, LocalAng = WorldToLocal( Pos, Angle(0,0,0), attachment.Pos, attachment.Ang )
	
	return LocalPos

end

function ENT:Beatlemania(n,m,p,t)

	if !m or !p then
		m=n
		p=1
	end
	
	p=hanim.ProcessDelta(p)
	
	local ent = self.Entity.anim
	
	if !(type(ent) == "Entity" or type(ent) == "NPC") then return end
	
	if !ent:IsPlayer() then
		if self.Entity.frames[n] and self.Entity.frames[n].hat then
			local physc = ent:GetPhysicsObjectCount()
			local flexn = ent:GetFlexNum()
			
			local f = self.Entity.frames[n]["flexscale"]
			if self.Entity.frames[m] and self.Entity.frames[m].hat then
				f = f+(self.Entity.frames[m]["flexscale"] - f)*hanim.ProcessDelta(p)
			end
			ent:SetFlexScale(f)
			
			if self.Entity.frames[n]["col"] then
				local col = self.Entity.frames[n]["col"]
				if self.Entity.frames[m] and self.Entity.frames[m]["col"] then
					local r = Lerp(p,col.r,self.Entity.frames[m]["col"].r)
					local g = Lerp(p,col.g,self.Entity.frames[m]["col"].g)
					local b = Lerp(p,col.b,self.Entity.frames[m]["col"].b)
					local a = Lerp(p,col.a,self.Entity.frames[m]["col"].a)
					col = Color(r,g,b,a)
				end
				ent:SetColor(col.r,col.g,col.b,col.a)
			end
			
			local physobj = ent:GetPhysicsObjectNum(0)
			local finalv = self.Entity.frames[n]["pos"]
			if self.Entity.frames[m] then
				if self.Entity.frames[m].hat then
					finalv = LerpVector(p,self.Entity.frames[n]["pos"],self.Entity.frames[m]["pos"])
				end
			end
			physobj:SetPos(finalv)
			physobj:Wake()
			
			local constrs = {}
			local constraints = constraint.FindConstraints(self.Entity.anim,"Weld")
			for _,const in pairs(constraints) do
				local selfbone = 0
				local consbone = 0
				//local conspos = 0
				for _,ent in pairs(const.Entity) do
					if ent.Entity != self.Entity.anim then
						consbone = ent.Entity:GetPhysicsObjectNum(ent.Entity:TranslateBoneToPhysBone(ent.Bone))
					else
						selfbone = ent.Bone
					end
				end
				//conspos = self.Entity.anim:GetPhysicsObjectNum(selfbone):WorldToLocal(consbone:GetPos())
				constrs[selfbone] = consbone
			end
			
			for i=0,math.Max(physc-1,flexn-1,VarsOnHand-1) do
				if i < physc then
				
					local physobj = ent:GetPhysicsObjectNum(i)
					physobj:EnableMotion(true)
					if self.Entity.frames[n]["phys_"..i].isfrozen then
						physobj:SetVelocity(Vector(100,100,100))
					end
					physobj:Wake()
					
					if i != 0 then
						if !t then
							physobj:SetPos(self.Entity.frames[n]["phys_"..i].pos)
							physobj:Wake()
						end
					end

					self.Entity.frames[n]["phys_"..i].ang = hanim.NormalizeAngle(self.Entity.frames[n]["phys_"..i].ang)
					
					local nang = self.Entity.frames[n]["phys_"..i].ang
					local finalang = nang
					
					if self.Entity.frames[m] then
						if self.Entity.frames[m].hat then
							self.Entity.frames[m]["phys_"..i].ang = hanim.NormalizeAngle(self.Entity.frames[m]["phys_"..i].ang)
							local mang = self.Entity.frames[m]["phys_"..i].ang
							finalang = LerpAngle(p,nang,mang) // FUCK YEAH, LERP LERP LERP LERP LERP LERP LERP LERP
							// SING IT WITH ME I LERP IT TO THE LERP SO I CAN LERP WHILE I LERP
							// LERPITY LERP LERP
							// LEERRRPP!!!
							// :D :D :D :D :D I LOVE YOU LERP, YOU ARE SO MAGICAL.
							// YOU SAVED ME WEEKS OF LEARNING QUATERNIONS. I AM FOREVER IN YOUR DEBT. LERP IT TO THE LERP
							// LERPA DERPA LERPA DERPA.
							// WHAT?! WHAT THE FUCK IS LERP YOU SAY? GET OUT. GET OUT OF MY LUA FILE. GET THE FUCK OUT NOOOOWWWWWW
						end
					end
					
					physobj:SetAngle(finalang)
					physobj:EnableMotion(false)
					physobj:Wake()
					
					if !t then
						if !self.Entity.frames[n]["phys_"..i].isfrozen then
							physobj:EnableMotion(true)
						end
					end
					
					if constrs[i] then
						local consbone = constrs[i]
						//local conspos = constrs[i][2]
						local BonePos,BoneAng = self.Entity.anim:GetBonePosition( i )
						consbone:SetPos(BonePos)
						//consbone:SetVelocity(Vector(100,100,100))
						//consbone:SetPos(physobj:LocalToWorld(conspos))
						//MsgN(physobj:LocalToWorld(conspos))
						//consbone:SetPos(physobj:LocalToWorld(Vector(0,0,0)))
						//consbone:EnableMotion(false)
						//consbone:Wake()
					end
					
					local b = ent:TranslatePhysBoneToBone(i)
					local inflation = self.Entity.frames[n]["inf"..b]
					if inflation then
						if self.Entity.frames[m]["inf"..b] then
							inflation = Lerp(p,inflation,self.Entity.frames[m]["inf"..b])
						end
						ent:SetNetworkedInt("InflateSize"..b,inflation)
					end
				end
				
				if i < flexn then
					local finalw = self.Entity.frames[n]["flex_"..i]
					if self.Entity.frames[m] and self.Entity.frames[m].hat then
						local deltaw = (self.Entity.frames[m]["flex_"..i] - self.Entity.frames[n]["flex_"..i])*hanim.ProcessDelta(p)
						finalw = finalw + deltaw
					end
					ent:SetFlexWeight(i,finalw)
				end
				
				if i < VarsOnHand then
					// Todo: Make finger interpolation clientsided
					local iHand = 0
					local Ang = self.Entity.frames[n]["finger_0_"..i]
					if self.Entity.frames[m] then
						if self.Entity.frames[m].hat then
							self.Entity.frames[m]["finger_0_"..i] = hanim.NormalizeAngle(self.Entity.frames[m]["finger_0_"..i])
							Ang = LerpAngle(p,self.Entity.frames[n]["finger_0_"..i],self.Entity.frames[m]["finger_0_"..i])
						end
					end
					ent:SetNetworkedAngle( "Finger".. i+(iHand*(VarsOnHand)), Ang )
					duplicator.StoreEntityModifier( ent, "finger", { [i+(iHand*(VarsOnHand))] = Ang } )
					local iHand = 1
					local Ang = self.Entity.frames[n]["finger_1_"..i]
					if self.Entity.frames[m] then
						if self.Entity.frames[m].hat then
							self.Entity.frames[m]["finger_1_"..i] = hanim.NormalizeAngle(self.Entity.frames[m]["finger_1_"..i])
							Ang = LerpAngle(p,self.Entity.frames[n]["finger_1_"..i],self.Entity.frames[m]["finger_1_"..i])
						end
					end
					ent:SetNetworkedAngle( "Finger".. i+(iHand*(VarsOnHand)), Ang )
					duplicator.StoreEntityModifier( ent, "finger", { [i+(iHand*(VarsOnHand))] = Ang } )
				end
			end
		end
	end
end

function ENT:Record(f)

	local ent = self.Entity.anim
	
	if !ent:IsValid() then return end
	
	self.Entity.frames[f] = {hat=true}
	
	local physc = ent:GetPhysicsObjectCount()
	local flexn = ent:GetFlexNum()
	local physobj = ent:GetPhysicsObjectNum(0)
	
	self.Entity.frames[f]["flexscale"] = ent:GetFlexScale()
	self.Entity.frames[f]["pos"] = physobj:GetPos()
	local r,g,b,a = ent:GetColor()
	local colors = Color(r,g,b,a)
	self.Entity.frames[f]["col"] = colors
	
	for i=0,math.Max(physc-1,flexn-1,VarsOnHand-1) do
		if i < physc then
			local physobj = ent:GetPhysicsObjectNum(i)
			self.Entity.frames[f]["phys_"..i] = {}
			self.Entity.frames[f]["phys_"..i].ang = physobj:GetAngles()
			self.Entity.frames[f]["phys_"..i].isfrozen = !physobj:IsMoveable()
			if i != 0 then
				self.Entity.frames[f]["phys_"..i].pos = physobj:GetPos()
			end
			// Because bone count is usually the same as physobj count.
			local b = ent:TranslatePhysBoneToBone(i)
			self.Entity.frames[f]["inf"..b] = ent:GetNetworkedInt("InflateSize"..b)
		end
		if i < flexn then
			self.Entity.frames[f]["flex_"..i] = ent:GetFlexWeight(i)
		end
		if i < VarsOnHand then
			local iHand = 0
			self.Entity.frames[f]["finger_0_"..i] = ent:GetNetworkedAngle( "Finger".. i+(iHand*(VarsOnHand)) )
			local iHand = 1
			self.Entity.frames[f]["finger_1_"..i] = ent:GetNetworkedAngle( "Finger".. i+(iHand*(VarsOnHand)) )
		end
	end
end

function ENT:SaveAnim(filename)
	file.Write(filename, glon.encode(self.Entity.frames))
end

function ENT:LoadAnim(filename)
	local decode = glon.decode(file.Read(filename))
	self.Entity.frames = decode
end

function ENT:InsertFrame(f)

	table.insert(self.Entity.frames,f,{})

end

function ENT:RemoveFrame(f)

	self.Entity.frames[f] = {}
	table.remove(self.Entity.frames,f)
	
end

function ENT:ClearFrame(f)

	self.Entity.frames[f] = {hat=false}

end

function ENT:OnRemove()
end