
AddCSLuaFile( "cl_init.lua" )
AddCSLuaFile( "shared.lua" )

include('shared.lua')

ENT.WireDebugName = "HAT Wire"


function ENT:Initialize()
	self.Entity:PhysicsInit( SOLID_VPHYSICS )
	self.Entity:SetMoveType( MOVETYPE_VPHYSICS )
	self.Entity:SetSolid( SOLID_VPHYSICS )
	self.Inputs = WireLib.CreateSpecialInputs(self.Entity, {}, {})
	self.Outputs = Wire_CreateOutputs(self.Entity, {"CurrentFrame", "Percent"})
end

function ENT:OnRemove()
	Wire_Remove(self.Entity)
end

function ENT:TriggerInput(iname, value)
end

function ENT:ShowOutput()
	local text = "HAT Outputer"
	if self.Outputs["CurrentFrame"] then
		text = text .. "\nCurrent Frame = "
		.. self.Outputs["CurrentFrame"].Value
		.. "\nPercentage = "
		.. self.Outputs["Percent"].Value
	end
	self:SetOverlayText( text )
end

function ENT:OnRestore()
	Wire_Restored(self.Entity)
end

function ENT:Think()
	self.BaseClass.Think(self)
	Wire_TriggerOutput(self.Entity,"CurrentFrame", hanim.CurFrame)
	local percent = 0
	if hanim.IsPlaying then
		percent = math.ceil(hanim.div((CurTime()-hanim.CurTime),hanim.GetFrameWang(hanim.CurFrame,true))*1000)/1000
	end
	Wire_TriggerOutput(self.Entity,"Percent", percent)
	
	self:ShowOutput()
	
	self.Entity:NextThink(CurTime() + 0.05)
	return true
end